<?php
/**
* SERVIRED per Arluk Software, S.L.
*basado en notify.php del core de virtuemart
*
*/

if ($_POST) {
   header("HTTP/1.0 200 OK");

    global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database,
    $mosConfig_mailfrom, $mosConfig_fromname;

        /*** access Joomla's configuration file ***/
        $my_path = dirname(__FILE__);

        if( file_exists($my_path."/../../../configuration.php")) {
            $absolute_path = dirname( $my_path."/../../../configuration.php" );
            require_once($my_path."/../../../configuration.php");
        }
        elseif( file_exists($my_path."/../../configuration.php")){
            $absolute_path = dirname( $my_path."/../../configuration.php" );
            require_once($my_path."/../../configuration.php");
        }
        elseif( file_exists($my_path."/configuration.php")){
            $absolute_path = dirname( $my_path."/configuration.php" );
            require_once( $my_path."/configuration.php" );
        }
        else {
            die( "Joomla Configuration File not found!" );
        }

        $absolute_path = realpath( $absolute_path );

        // Set up the appropriate CMS framework
        if( class_exists( 'jconfig' ) ) {
			define( '_JEXEC', 1 );
			define( 'JPATH_BASE', $absolute_path );
			define( 'DS', DIRECTORY_SEPARATOR );

			// Load the framework
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );

			// create the mainframe object
			$mainframe = & JFactory::getApplication( 'site' );

			// Initialize the framework
			$mainframe->initialise();

			// load system plugin group
			JPluginHelper::importPlugin( 'system' );

			// trigger the onBeforeStart events
			$mainframe->triggerEvent( 'onBeforeStart' );
			$lang =& JFactory::getLanguage();
			$mosConfig_lang = $GLOBALS['mosConfig_lang']          = strtolower( $lang->getBackwardLang() );
			// Adjust the live site path
			$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
			$mosConfig_absolute_path = JPATH_BASE;
        } else {
        	define('_VALID_MOS', '1');
        	require_once($mosConfig_absolute_path. '/includes/joomla.php');
        	require_once($mosConfig_absolute_path. '/includes/database.php');
        	$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
        	$mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path );
        }

       // load Joomla Language File
        if (file_exists( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' )) {
            require_once( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' );
        }
        elseif (file_exists( $mosConfig_absolute_path. '/language/english.php' )) {
            require_once( $mosConfig_absolute_path. '/language/english.php' );
        }
    /*** END of Joomla config ***/ /*** VirtueMart part ***/
        require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
        include_once( ADMINPATH.'/compat.joomla1.5.php' );
        require_once( ADMINPATH. 'global.php' );
        require_once( CLASSPATH. 'ps_main.php' );

        /* @MWM1: Logging enhancements (file logging & composite logger). */
        $vmLogIdentifier = "notify.php";
        require_once(CLASSPATH."Log/LogInit.php");


		$debug_email_address = $mosConfig_mailfrom;
	    // restart session
	    // Constructor initializes the session!
	    $sess = new ps_session();

    /*** END VirtueMart part ***/


    //1. Finished Initialization of the notify_servired.php script"

    /**
    * Read post from Servired system and update order status
    **/
    $i = 1;

    $Ds_Date = trim(stripslashes($_POST['Ds_Date']));
    $Ds_Hour = trim(stripslashes($_POST['Ds_Hour']));
    $Ds_Amount = trim(stripslashes($_POST['Ds_Amount']));
    $Ds_Currency = trim(stripslashes($_POST['Ds_Currency']));
    $Ds_Order = trim(stripslashes($_POST['Ds_Order']));

    // Can be USD, GBP, EUR, CAD, JPY
    $Ds_MerchantCode =  trim(stripslashes($_POST['Ds_MerchantCode']));

    $Ds_Terminal = trim(stripslashes($_POST['Ds_Terminal']));
    $Ds_Signature = trim(stripslashes($_POST['Ds_Signature']));
	//respuesta de la transaccin valores entre 0000 a 0099 indican que correcto
    $Ds_Response = trim(stripslashes($_POST['Ds_Response']));

    $Ds_TransactionType = trim(stripslashes($_POST['Ds_TransactionType']));
    $Ds_AuthorisationCode =  trim(stripslashes($_POST['Ds_AuthorisationCode']));


      // Get the Order Details from the database
      // Get the Order Details from the database
      $qv = "SELECT `order_id`, `order_number`, `user_id`, `order_subtotal`,
                    `order_total`, `order_currency`, `order_tax`,
                    `order_shipping_tax`, `coupon_discount`, `order_discount`
                FROM `#__{vm}_orders`
                WHERE `order_id`='".intval($Ds_Order)."'";
      $db = new ps_DB;
      $db->query($qv);
      $db->next_record();
      $order_id = $db->f("order_id");

      $d['order_id'] = $order_id;
      $d['notify_customer'] = "Y";

	 	$clave='clave_negocio';                     // Clave de comercio proporcionada por Sermepa.
		$name='nombre_negocio';                        // Nombre del comercio que sale en la transaccion.
		$code='codigo_negocio';                        // Codigo de comercio proporcionado por Sermepa.
		$terminal='1';                                      // Terminal usado.
		$currency='978';                                      // 978=Euros.
		$tipoOperacion='0';                                   // Tipo de operacion. 0=Autorizacion.
				// Calculo del hash para firmar los datos.
		$order = '000'.$order_id;
		$amount=$db->f("order_total")*100;
		$message = $amount.$order.$code.$currency.$Ds_Response.$clave;
		$signature = strtoupper(sha_1($message));
     if($Ds_Signature==$signature){
			//-------------------------------------------
		  // ...read the results of the verification...
		  // If $Ds_Response esta entre 0000 y 0099 la transaccin ha ido bien
		  //-------------------------------------------
		if (intval ( $Ds_Response)>=0 &&  intval ( $Ds_Response)<100 ) {

			// UPDATE THE ORDER STATUS to 'Completed'
				$d['order_status'] = "C";
			require_once ( CLASSPATH . 'ps_order.php' );
                $ps_order= new ps_order;
                $ps_order->order_status_update($d);
			/*$mail->From = $mosConfig_mailfrom;
			$mail->FromName = $mosConfig_fromname;
			$mail->AddAddress($debug_email_address);
			$mail->Subject = "SERVIRED IPN txn on your site";
			$mail->Body = "Hello,\n\n";
			$mail->Body .= "a SERVIRED transaction for you has been made on your website!\n";
			$mail->Body .= "-----------------------------------------------------------\n";
			$mail->Body .= "Order ID: $order_id\n";
			$mail->Body .= "Payment Status returned by SERVIRED: $Ds_Response\n";
			$mail->Body .= "Order Status Code: ".$d['order_status'];
			$mail->Send();*/
			$mailsubject= "SERVIRED IPN txn on your site";
			$mailbody= "Hello,\n\n";
			$mailbody .= "a SERVIRED transaction for you has been made on your website!\n";
			$mailbody .= "-----------------------------------------------------------\n";
			$mailbody .= "Order ID: $order_id\n";
			$mailbody .= "Payment Status returned by SERVIRED: $Ds_Response\n";
			$mailbody .= "Order Status Code: ".$d['order_status'];
			 vmMail($mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody );
		}
		else {
				$d['order_status'] = "X";
			require_once ( CLASSPATH . 'ps_order.php' );
                $ps_order= new ps_order;
                $ps_order->order_status_update($d);
				/*$mail->From = $mosConfig_mailfrom;
				$mail->FromName = $mosConfig_fromname;
				$mail->AddAddress($debug_email_address);
				$mail->Subject = "SERVIRED Transaction on your Site";
				$mail->Body = "Hello,
				An error occured while processing a SERVIRED transaction.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response";
				$mail->Send();*/
				$mailsubject= "SERVIRED Transaction on your Site";
			$mailbody= "Hello,
				An error occured while processing a SERVIRED transaction.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response";

			 vmMail($mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody );
		}
	 }
	 else{
	 	/*$mail->From = $mosConfig_mailfrom;
				$mail->FromName = $mosConfig_fromname;
				$mail->AddAddress($debug_email_address);
				$mail->Subject = "SERVIRED Transaction on your Site";
				$mail->Body = "Hello,
				Se ha recibido una transaccin de SERVIRED con una firma erronea.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response\n
					Cantidad recibida= $Ds_Amount.
					Cantidad pedido: $amount.
					order_servired=$Ds_Order\n
					Firma recibida=$Ds_Signature\n
					Firma generada=$signature\n
					";

				$mail->Send();*/
				$mailsubject= "SERVIRED Transaction on your Site";
			$mailbody= "Hello,
				Se ha recibido una transaccin de SERVIRED con una firma erronea.
				----------------------------------
					Order ID: $order_id\n
					Order Status Code:$Ds_Response\n
					Cantidad recibida= $Ds_Amount.
					Cantidad pedido: $amount.
					order_servired=$Ds_Order\n
					Firma recibida=$Ds_Signature\n
					Firma generada=$signature\n
					";

			 vmMail($mosConfig_mailfrom, $mosConfig_fromname, $debug_email_address, $mailsubject, $mailbody );
	 }

}

/*
** Date modified: 1st October 2004 20:09 GMT
*
** PHP implementation of the Secure Hash Algorithm ( SHA-1 )
*
** This code is available under the GNU Lesser General Public License:
** http://www.gnu.org/licenses/lgpl.txt
*
** Based on the PHP implementation by Marcus Campbell
** http://www.tecknik.net/sha-1/
*
** This is a slightly modified version by me Jerome Clarke ( sinatosk@gmail.com )
** because I feel more comfortable with this
*/

function sha1_str2blks_SHA1($str)
{
   $strlen_str = strlen($str);

   $nblk = (($strlen_str + 8) >> 6) + 1;

   for ($i=0; $i < $nblk * 16; $i++) $blks[$i] = 0;

   for ($i=0; $i < $strlen_str; $i++)
   {
       $blks[$i >> 2] |= ord(substr($str, $i, 1)) << (24 - ($i % 4) * 8);
   }

   $blks[$i >> 2] |= 0x80 << (24 - ($i % 4) * 8);
   $blks[$nblk * 16 - 1] = $strlen_str * 8;

   return $blks;
}

function sha1_safe_add($x, $y)
{
   $lsw = ($x & 0xFFFF) + ($y & 0xFFFF);
   $msw = ($x >> 16) + ($y >> 16) + ($lsw >> 16);

   return ($msw << 16) | ($lsw & 0xFFFF);
}

function sha1_rol($num, $cnt)
{
   return ($num << $cnt) | sha1_zeroFill($num, 32 - $cnt);
}

function sha1_zeroFill($a, $b)
{
   $bin = decbin($a);

   $strlen_bin = strlen($bin);

   $bin = $strlen_bin < $b ? 0 : substr($bin, 0, $strlen_bin - $b);

   for ($i=0; $i < $b; $i++) $bin = '0'.$bin;

   return bindec($bin);
}

function sha1_ft($t, $b, $c, $d)
{
   if ($t < 20) return ($b & $c) | ((~$b) & $d);
   if ($t < 40) return $b ^ $c ^ $d;
   if ($t < 60) return ($b & $c) | ($b & $d) | ($c & $d);

   return $b ^ $c ^ $d;
}

function sha1_kt($t)
{
   if ($t < 20) return 1518500249;
   if ($t < 40) return 1859775393;
   if ($t < 60) return -1894007588;

   return -899497514;
}

function sha_1($str, $raw_output=FALSE)
{
   if ( $raw_output === TRUE ) return pack('H*', sha_1($str, FALSE));

   $x = sha1_str2blks_SHA1($str);
   $a =  1732584193;
   $b = -271733879;
   $c = -1732584194;
   $d =  271733878;
   $e = -1009589776;

   $x_count = count($x);

   for ($i = 0; $i < $x_count; $i += 16)
   {
       $olda = $a;
       $oldb = $b;
       $oldc = $c;
       $oldd = $d;
       $olde = $e;

       for ($j = 0; $j < 80; $j++)
       {
           $w[$j] = ($j < 16) ? $x[$i + $j] : sha1_rol($w[$j - 3] ^ $w[$j - 8] ^ $w[$j - 14] ^ $w[$j - 16], 1);

           $t = sha1_safe_add(sha1_safe_add(sha1_rol($a, 5), sha1_ft($j, $b, $c, $d)), sha1_safe_add(sha1_safe_add($e, $w[$j]), sha1_kt($j)));
           $e = $d;
           $d = $c;
           $c = sha1_rol($b, 30);
           $b = $a;
           $a = $t;
       }

       $a = sha1_safe_add($a, $olda);
       $b = sha1_safe_add($b, $oldb);
       $c = sha1_safe_add($c, $oldc);
       $d = sha1_safe_add($d, $oldd);
       $e = sha1_safe_add($e, $olde);
   }

   return sprintf('%08x%08x%08x%08x%08x', $a, $b, $c, $d, $e);
}
?>
?>
